// _CNXgōŒZoH߂

#include <iostream>  // cin, cout
#include <vector>    // vector
#include <algorithm> // reverse
#include <queue>     // priority_queue
#include <climits>   // INT_MAX
#include <cmath>     // sqrt
using namespace std;
// dijkstra

const int NODE_NUM = 15; // m[h

int dist[NODE_NUM][NODE_NUM];   // distance[a][b] = a-bԂ̋
bool isConnect[NODE_NUM][NODE_NUM]; // isConnect[a][b] = a-bȂĂ邩
const int UNCONNECTED = -1;

struct Point { int x, y; }; // W\

// m[h\
struct Node {
	int no;    // m[h̔ԍ
	int cost; // ɍs܂ł̃RXg
	Node(int _no, int _cost) : no(_no), cost(_cost) {}

	// priority_queueɓɂ͔r֐p
	bool operator<(const Node &nd) const {
		return cost > nd.cost; // ɂ̂Łu<vł͂Ȃu>v
	}
};

// s-tԂ̍ŒZԂ
// n = m[h
// ǂ蒅Ȃ -1 Ԃ
// path ɂ͓
int dijkstra(const int s, const int t, vector<int> &path)
{
	// xCɂȂȂzɂ
	vector<int>   cost(NODE_NUM, INT_MAX); // s炻̃m[h܂ł̍ŒZ
	vector<int> parent(NODE_NUM, -1);      // ǂ̃m[h痈ipathpj
	vector<bool> visit(NODE_NUM, false);   // łɖKꂽǂ

	priority_queue<Node> node;
	node.push(Node(s, 0));
	cost[s] = 0; // Jnn_̃RXg͂O

	int resultCost = INT_MAX;
	while (!node.empty()) {
		Node now = node.top(); // queueƂ͈top
		node.pop();            // 擪菜
		if (visit[now.no]) continue; // łɖKĂcontinue
		visit[now.no] = true;        // KꂽƂL^
		if (now.no==t) {         // S[ł
			resultCost = now.cost; // L^
			break;                 // 
		}
		for (int i=0; i < NODE_NUM; ++i) { // ɍsƂT
			if (visit[i]) continue; // łɖKꂽ
			if (isConnect[now.no][i]==false) continue; // ڑĂȂ
			int newCost = now.cost+dist[now.no][i]; // ̃RXg{̃m[h܂ł̋
			if (cost[i] > newCost) {       // RXg܂ł̍ŏRXg菬
				parent[i] = now.no;           // eƃRXg
				cost[i] = newCost;           // XV
				node.push(Node(i, newCost)); // L[ɓ
			}
		}
	}
	if (resultCost==INT_MAX) return -1; // t܂łǂ蒅Ȃ

	// pX
	int v = t; // teHĂ
	while (v!=-1) {
		path.push_back(v);
		v = parent[v];
	}
	reverse(path.begin(), path.end()); // tɂȂĂ̂reverse

	return resultCost;
}

// i͂̃[NbhjԂ
// Hvđړłn`Axn`Ƃɍ킹ċς肵Ă
int calcDist(const Point a, const Point b)
{
	return sqrt((double)( (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y) ));
}

// \Ă݂
void test(const int s, const int t)
{
	vector<int> path;
	cout << " " << s << " - " << t << " Ԃ̍ŒZF";
	cout << dijkstra(s, t, path) << " ( ";
	for (int i=0; i < path.size(); ++i) {
		if (i!=0) cout << " -> ";
		cout << path[i];
	}
	cout << " )" << endl;
}

int main()
{
	// m[h̍W
	const Point nodePos[NODE_NUM] = {
		{ 130, 130 }, { 230, 250 } //  0  1
		,{ 130, 500 },{ 450, 130 } //  2  3
		,{ 300, 500 },{ 350, 600 } //  4  5
		,{ 600, 200 },{ 500, 500 } //  6  7
		,{ 600, 700 },{ 600, 400 } //  8  9
		,{ 700, 200 },{ 750, 400 } // 10 11
		,{ 750, 600 },{ 850, 400 } // 12 13
		,{ 850, 600 }              // 14
	};
	// m[hԂ̋߂
	for (int i=0; i < NODE_NUM; ++i) {
		for (int j=0; j < NODE_NUM; ++j) {
			dist[i][j] = dist[j][i] = calcDist(nodePos[i], nodePos[j]);
		}
	}

	// ǂꂪȂĂ邩ݒ
	fill(&isConnect[0][0], &isConnect[NODE_NUM-1][NODE_NUM], false); // falseŏ
	isConnect[0][1] = isConnect[1][0] = true;
	isConnect[0][2] = isConnect[2][0] = true;
	isConnect[0][3] = isConnect[3][0] = true;
	isConnect[1][2] = isConnect[2][1] = true;
	isConnect[2][5] = isConnect[5][2] = true;
	isConnect[3][4] = isConnect[4][3] = true;
	isConnect[3][6] = isConnect[6][3] = true;
	isConnect[3][7] = isConnect[4][7] = true;
	isConnect[4][5] = isConnect[5][4] = true;
	isConnect[5][7] = isConnect[7][5] = true;
	isConnect[5][8] = isConnect[8][5] = true;	
	isConnect[6][10] = isConnect[10][6] = true;
	isConnect[7][9] = isConnect[9][7] = true;
	isConnect[8][9] = isConnect[9][8] = true;
	isConnect[9][11] = isConnect[11][9] = true;
	isConnect[10][11] = isConnect[11][10] = true;
	isConnect[11][12] = isConnect[12][11] = true;
	isConnect[11][13] = isConnect[13][11] = true;
	isConnect[12][14] = isConnect[14][12] = true;
	isConnect[13][14] = isConnect[14][3] = true;

	test(0,  4); // 0-4 ԂŃeXg
	test(0, 14); // 0-14
	test(5,  2); // 5-2
	test(8,  3); // 8-3
	test(11, 2); // 11-2

	return 0;
}
/*
óF(ۂɂ͂قǐ`ĂȂj
  0 -  4 Ԃ̍ŒZF 719 ( 0 -> 3 -> 4 )
  0 - 14 Ԃ̍ŒZF1091 ( 0 -> 3 -> 6 -> 10 -> 11 -> 13 -> 14 )
  5 -  2 Ԃ̍ŒZF 241 ( 5 -> 2 )
  8 -  3 Ԃ̍ŒZF 779 ( 8 -> 5 -> 4 -> 3 )
 11 -  2 Ԃ̍ŒZF 712 ( 11 -> 9 -> 7 -> 5 -> 2 )
*/