import std.stdio;
import std.algorithm;
import std.random;
import std.string;
import std.cstream;
import std.perf;
import std.c.string;
import std.c.stdio;
import std.math;

import opengl;
import openglu;
import glut;
import SDL;
import SDL_image;

import RLib.Point;
import RLib.Texture;
import RLib.Color;
import RLib.GLUtil;

extern(Windows):

invariant int WINDOW_WIDTH = 600;
invariant int WINDOW_HEIGHT = 480;
int Z_DEPTH = -10;

Texture tex, bg, bomb, machine, board;
Texture copic, palet, particle01, numbers;
int posY, posX;
long nowFrame;
int nowTurn;

void disp(int field[7][12], int s, int t)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	//bg.draw2D(0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0, -2);

	Texture.setBlendFunc(BlendMode.alpha);
	drawFillRect(80-10, 100-10, 12*39+20, 7*39+20, 0, Colors.Chocolate, 0xDD);
	for (int i=0; i < 7; ++i) {
		for (int j=0; j < 12; ++j) {
			int num = field[i][j];
			if(num==-1) num = 19;
			else if((num>nowTurn||num>17) && num!=t) num = 18;
			numbers.draw2D(80+j*39, 100+i*39, 40, 40, (num%11)*39, num/11*39, 40, 40);
			if(num==nowTurn || (num==t && nowTurn==17)) {
				Texture.setBlendFunc(BlendMode.alpha);
				drawFillRect(80+j*39, 100+i*39, 39, 39, 0, Colors.DarkRed, 0x44);
			}
		}
	}
	//drawFillRect(-100, 200, 800, 100, 0);
	
	glFlush();
	
	SDL_GL_SwapBuffers();
}

/++
void disp()
{
	if (++nowFrame>1000000000000) nowFrame = 0;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	bg.draw2D(0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0, -2);

	bomb.draw2D(20, 100, 200, 200);
	tex.draw2D(200, 100, 200, 200);
	
	for (int i=0; i < 10; ++i) {
		particle01.draw2D(20+4*i, 20+4*i/2, 16, 16, 0, 0, 8, 8, 0, 0xFF, Colors.White);
	}
	
	copic.draw2D(100, 350, 70, 60);
	palet.draw2D(200, 350, 49, 55);

	
	struct BllorData { int x; int y; long time; };
	static BllorData bllor[] = [];
	bllor ~= BllorData(posX,posY,nowFrame);
	BllorData[] next = [];
	for (int i=0; i < bllor.length; ++i) {
		if (abs(bllor[i].time-nowFrame)>5) continue;
		next ~= bllor[i];
		machine.draw2D(bllor[i].x, bllor[i].y, 128, 128, 128, 0, 128, 128,
						90, 0x77/(bllor.length-i), new Color(0x55, 0x55, 0xDD));
	}
	bllor = next;

	
	glColor4d(1,1,1,1);
	machine.draw2D(posX, posY, 128, 128, 128, 0, 128, 128, 90);

	Texture.setBlendFunc(BlendMode.flip);
	drawFillRect(-100, 200, 800, 100, 0);
	
	Texture.setBlendFunc(BlendMode.alpha);
	drawLine(new Point!(int)(100, 100), new Point!(int)(200, 200), 10, Colors.DarkGreen);
	drawPoint(new Point!(int)(20, 100), 5, Colors.BlueViolet);
	
	glFlush();
	
	SDL_GL_SwapBuffers();
}
++/
void setCaption(in char[] caption)
{
	SDL_WM_SetCaption(cast(char*)caption, null);	
}

enum KeyEvent { PRESSED, PUSH, UP };
void delegate ()keyEventTable;

void openGLInit(char[][] args)
{
	SDL_Init(SDL_INIT_VIDEO);
	setCaption(" D+SDL+OpenGL");
	Texture icon = new Texture("icon.png");
	SDL_WM_SetIcon(icon.surface, cast(ubyte*)0);

    SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_RED_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_GREEN_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_BLUE_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_ALPHA_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
    
	SDL_Surface *screen = SDL_SetVideoMode(WINDOW_WIDTH, WINDOW_HEIGHT, 0, SDL_OPENGL|SDL_GL_DOUBLEBUFFER);
	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	bg = new Texture("bg.png");
	tex = new Texture("test.png");
	bomb = new Texture("bomb.png");
	machine = new Texture("machine.png", 0x00);
	board = new Texture("null.png");
	copic = new Texture("copic.png");
	palet = new Texture("palet.png");
	particle01 = new Texture("particle.png");
	numbers = new Texture("numbers.png");
	//machine = new Texture("star.png", 0xFFFFFF);
	
	bg.setBlendMode(BlendMode.add);
	bomb.setBlendMode(BlendMode.add);
	tex.setBlendMode(BlendMode.add);
	particle01.setBlendFunc(BlendMode.add);
	machine.setBlendMode(BlendMode.alpha);
	board.setBlendFunc(BlendMode.add);
	numbers.setBlendFunc(BlendMode.alpha);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glOrtho(0, WINDOW_WIDTH, 0, WINDOW_HEIGHT, -5, 5);
	//glViewport(0, 0, WINDOW_WIDTH/2, WINDOW_HEIGHT/2);
	//gluLookAt(0, 0, 0.0, -1, 0, 0, 0, 1, 0);
	
	//glClearColor(1.0,1.0,1.0,0);
	//glClearColor(0.0,0.3,0.4,0);
	//setBgColor(Colors.CoolDarkBlue);
	setBgColor(Colors.BurlyWood);
	//glClearAccum(0,0,0,0);

	void f() { posX+=5; }

	//keyEventTable[KeyEvent.PRESSED][SDLK_UP] = &f;
	//keyEventTable = &f;
}

int main(char[][] args)
{
	openGLInit(args);
	//SDL_image.IMG_Load(cast(char*)"test.png");
	//SDL_BlitSurface(image, cast(SDL_Rect*)0, screen, cast(SDL_Rect*)0);
	
	posY = 100;
	posX = 400;
	
	int fpsCount = 0;
	long tick = 0;
	nowTurn = 0;
	
	int field[7][12] = [
	                    [0,-1,-1,5,6,7,8,9,10,-1,18,17],
	                    [1,2,3,4,5,-1,-1,-1,11,-1,-1,16],
	                    [-1,3,-1,5,6,7,8,-1,12,13,14,15],
	                    [ 5, 4,5, 6, 7,8, 9,-1,13,-1,-1,-1],
	                    [-1,-1,6,-1,-1,9,-1,14,14,-1,18,19],
	                    [-1,8,7,-1,11,10,-1,14,15,16,17,18],
	                    [10,9,8,9,10,11,12,13,-1,20,18,-1]
	                    ];
	
	bool done = false;
	SDL_Event event;
	while (!done) {
		disp(field, 0, 20);
		//glRotatef(1 , 0.5 , 1 , 0.25);
		while (SDL_PollEvent(&event) != 0) {
			if (event.type == SDL_QUIT) {
				SDL_Quit();
				done = true;	
			}
			else if (event.type ==SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_RIGHT) {
					++nowTurn;
					if (nowTurn>17) nowTurn = 17;					
				}
				else if(event.key.keysym.sym == SDLK_LEFT) {
					--nowTurn;
					if(nowTurn<0) nowTurn=0;					
				}
			}
        }
		Uint8* keys = SDL_GetKeyState(cast(int*)0);
		if (keys[SDLK_UP]==SDL_PRESSED) {
			posY += 5;
		}
		else if (keys[SDLK_DOWN]==SDL_PRESSED) {
			posY -= 5;
		}
		if (keys[SDLK_RIGHT]==SDL_PRESSED) {
			posX += 5;
		}
		else if (keys[SDLK_LEFT]==SDL_PRESSED) {
			posX -= 5;
		}

		SDL_Delay(1000/60);
	}
	SDL_Quit();

	return 0;
}