import std.stdio;
import std.algorithm;
import std.random;
import std.string;
import std.cstream;
import std.perf;
import std.c.string;
import std.c.stdio;
import std.math;

import opengl;
import openglu;
import glut;
import SDL;
import SDL_image;

import RLib.Point;
import RLib.Texture;
import RLib.Color;
import RLib.GLUtil;

extern(Windows):

invariant int WINDOW_WIDTH = 600;
invariant int WINDOW_HEIGHT = 480;
int Z_DEPTH = -10;

Texture tex, bg, bomb, machine, board;
Texture copic, palet, particle01, numbers;
int posY, posX;
long nowFrame;
Texture human;
bool goRight;

int rot=0;

void disp()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	Point!(int)[] pt;
	pt ~= new Point!(int)(0, 100);
	pt ~= new Point!(int)(100, 100);
	pt ~= new Point!(int)(200, 300);
	pt ~= new Point!(int)(250, 300);
	pt ~= new Point!(int)(300, 200);
	pt ~= new Point!(int)(500, 250);
	pt ~= new Point!(int)(640, 100);
	pt ~= new Point!(int)(650, 100);
	
	int pos = 0;
	for (int i=0; i < pt.length-1; ++i){
		drawLine(pt[i], pt[i+1], 5, Colors.Black);
		if (pt[i].x < posX && posX <= pt[i+1].x) {
			pos = i;
			double posRate = (posX-pt[i].x)/cast(double)(pt[i+1].x-pt[i].x);
			if (posRate==double.nan) posRate=1;
			posY = cast(int)(pt[i].y + (pt[i+1].y - pt[i].y)*posRate);
			double a = atan((pt[i+1].y-pt[i].y)/cast(double)(pt[i+1].x-pt[i].x));
			rot = cast(int)(a/PI*180);
		}
	}
	int[] adj;
	adj ~= 0;
	adj ~= -30;
	adj ~= 0;
	adj ~= 30;
	adj ~= 0;
	adj ~= 20;
	adj ~= 0;
	
	if (goRight) {
		human.draw2D(posX-43+adj[pos], posY, 87, 115, 0, 0, 87, 115, rot);
	}
	else {
		human.draw2D(posX+43+adj[pos], posY, -87, 115, 0, 0, 87, 115, rot);
	}
	
	SDL_GL_SwapBuffers();
}

/++
void disp()
{
	if (++nowFrame>1000000000000) nowFrame = 0;

glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	bg.draw2D(0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0, -2);

	bomb.draw2D(20, 100, 200, 200);
	tex.draw2D(200, 100, 200, 200);
	
	for (int i=0; i < 10; ++i) {
		particle01.draw2D(20+4*i, 20+4*i/2, 16, 16, 0, 0, 8, 8, 0, 0xFF, Colors.White);
	}
	
	copic.draw2D(100, 350, 70, 60);
	palet.draw2D(200, 350, 49, 55);

	
	struct BllorData { int x; int y; long time; };
	static BllorData bllor[] = [];
	bllor ~= BllorData(posX,posY,nowFrame);
	BllorData[] next = [];
	for (int i=0; i < bllor.length; ++i) {
		if (abs(bllor[i].time-nowFrame)>5) continue;
		next ~= bllor[i];
		machine.draw2D(bllor[i].x, bllor[i].y, 128, 128, 128, 0, 128, 128,
						90, 0x77/(bllor.length-i), new Color(0x55, 0x55, 0xDD));
	}
	bllor = next;

	
	glColor4d(1,1,1,1);
	machine.draw2D(posX, posY, 128, 128, 128, 0, 128, 128, 90);

	Texture.setBlendFunc(BlendMode.flip);
	drawFillRect(-100, 200, 800, 100, 0);
	
	Texture.setBlendFunc(BlendMode.alpha);
	drawLine(new Point!(int)(100, 100), new Point!(int)(200, 200), 10, Colors.DarkGreen);
	drawPoint(new Point!(int)(20, 100), 5, Colors.BlueViolet);
	
	glFlush();

	SDL_GL_SwapBuffers();
}
++/

void setCaption(in char[] caption)
{
	SDL_WM_SetCaption(cast(char*)caption, null);	
}

enum KeyEvent { PRESSED, PUSH, UP };
void delegate ()keyEventTable;

void openGLInit(char[][] args)
{
	SDL_Init(SDL_INIT_VIDEO);
	setCaption(" D+SDL+OpenGL");
	Texture icon = new Texture("icon.png");
	SDL_WM_SetIcon(icon.surface, cast(ubyte*)0);

    SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_RED_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_GREEN_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_BLUE_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_ACCUM_ALPHA_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
    
	SDL_Surface *screen = SDL_SetVideoMode(WINDOW_WIDTH, WINDOW_HEIGHT, 0, SDL_OPENGL|SDL_GL_DOUBLEBUFFER);
	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	/++
	bg = new Texture("bg.png");
	tex = new Texture("test.png");
	bomb = new Texture("bomb.png");
	machine = new Texture("machine.png", 0x00);
	board = new Texture("null.png");
	copic = new Texture("copic.png");
	palet = new Texture("palet.png");
	particle01 = new Texture("particle.png");
	
	bg.setBlendMode(BlendMode.add);
	bomb.setBlendMode(BlendMode.add);
	tex.setBlendMode(BlendMode.add);
	particle01.setBlendFunc(BlendMode.add);
	machine.setBlendMode(BlendMode.alpha);
	board.setBlendFunc(BlendMode.add);
	numbers.setBlendFunc(BlendMode.alpha);
	++/
	
	human = new Texture("human.png", 0xFFFFFF);
	human.setBlendMode(BlendMode.alpha);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glOrtho(0, WINDOW_WIDTH, 0, WINDOW_HEIGHT, -5, 5);
	//glViewport(0, 0, WINDOW_WIDTH/2, WINDOW_HEIGHT/2);
	//gluLookAt(0, 0, 0.0, -1, 0, 0, 0, 1, 0);
	
	//glClearColor(1.0,1.0,1.0,0);
	//glClearColor(0.0,0.3,0.4,0);
	//setBgColor(Colors.CoolDarkBlue);
	setBgColor(Colors.White);
	//glClearAccum(0,0,0,0);

	void f() { posX+=5; }

	//keyEventTable[KeyEvent.PRESSED][SDLK_UP] = &f;
	//keyEventTable = &f;
}

int main(char[][] args)
{
	openGLInit(args);
	//SDL_image.IMG_Load(cast(char*)"test.png");
	//SDL_BlitSurface(image, cast(SDL_Rect*)0, screen, cast(SDL_Rect*)0);
	
	posX = 1;
	
	int fpsCount = 0;
	long tick = 0;
	goRight = true;
	
	bool done = false;
	SDL_Event event;
	while (!done) {
		disp();
		//glRotatef(1 , 0.5 , 1 , 0.25);
		while (SDL_PollEvent(&event) != 0) {
			if (event.type == SDL_QUIT) {
				SDL_Quit();
				done = true;	
			}
        }
		Uint8* keys = SDL_GetKeyState(cast(int*)0);
		if (keys[SDLK_UP]==SDL_PRESSED) {
			posY += 5;
		}
		else if (keys[SDLK_DOWN]==SDL_PRESSED) {
			posY -= 3;
		}
		if (keys[SDLK_RIGHT]==SDL_PRESSED) {
			posX += 3*cos(rot*PI/180.0);
			if (rot!=0) posX+=1;
			goRight = true;
		}
		else if (keys[SDLK_LEFT]==SDL_PRESSED) {
			posX -= 3*cos(rot*PI/180.0);
			goRight = false;
		}

		SDL_Delay(1000/60);
	}
	SDL_Quit();

	return 0;
}